Index: serefpolicy-contrib-20140730/spamassassin.if
===================================================================
--- serefpolicy-contrib-20140730.orig/spamassassin.if
+++ serefpolicy-contrib-20140730/spamassassin.if
@@ -2,39 +2,45 @@
 
 ########################################
 ## <summary>
-##	Role access for spamassassin.
+##	Role access for spamassassin
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`spamassassin_role',`
 	gen_require(`
 		type spamc_t, spamc_exec_t, spamc_tmp_t;
-		type spamassassin_t, spamassassin_exec_t, spamd_home_t;
+		type spamassassin_t, spamassassin_exec_t;
 		type spamassassin_home_t, spamassassin_tmp_t;
 	')
 
 	role $1 types { spamc_t spamassassin_t };
 
 	domtrans_pattern($2, spamassassin_exec_t, spamassassin_t)
+
+	allow $2 spamassassin_t:process signal_perms;
+	ps_process_pattern($2, spamassassin_t)
+
 	domtrans_pattern($2, spamc_exec_t, spamc_t)
 
-	allow $2 { spamc_t spamassassin_t}:process { ptrace signal_perms };
-	ps_process_pattern($2, { spamc_t spamassassin_t })
+	allow $2 spamc_t:process signal_perms;
+	ps_process_pattern($2, spamc_t)
 
-	allow $2 { spamc_tmp_t spamd_home_t spamassassin_home_t spamassassin_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { spamc_tmp_t spamd_home_t spamassassin_home_t spamassassin_tmp_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 { spamc_tmp_t spamd_home_t spamassassin_home_t spamassassin_tmp_t }:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	userdom_user_home_dir_filetrans($2, spamassassin_home_t, dir, ".spamassassin")
-	userdom_user_home_dir_filetrans($2, spamd_home_t, dir, ".spamd")
+	manage_dirs_pattern($2, spamassassin_home_t, spamassassin_home_t)
+	manage_files_pattern($2, spamassassin_home_t, spamassassin_home_t)
+	manage_lnk_files_pattern($2, spamassassin_home_t, spamassassin_home_t)
+	relabel_dirs_pattern($2, spamassassin_home_t, spamassassin_home_t)
+	relabel_files_pattern($2, spamassassin_home_t, spamassassin_home_t)
+	relabel_lnk_files_pattern($2, spamassassin_home_t, spamassassin_home_t)
 ')
 
 ########################################
@@ -53,13 +59,12 @@ interface(`spamassassin_exec',`
 		type spamassassin_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, spamassassin_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Send generic signals to spamd.
+##	Singnal the spam assassin daemon
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -77,7 +82,8 @@ interface(`spamassassin_signal_spamd',`
 
 ########################################
 ## <summary>
-##	Execute spamd in the caller domain.
+##	Execute the spamassassin daemon
+##	program in the caller directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -90,13 +96,12 @@ interface(`spamassassin_exec_spamd',`
 		type spamd_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, spamd_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute spamc in the spamc domain.
+##	Execute spamassassin client in the spamassassin client domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -109,32 +114,13 @@ interface(`spamassassin_domtrans_client'
 		type spamc_t, spamc_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, spamc_exec_t, spamc_t)
+	allow $1 spamc_exec_t:file ioctl;
 ')
 
 ########################################
 ## <summary>
-##	Execute spamc in the caller domain.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`spamassassin_exec_client',`
-	gen_require(`
-		type spamc_exec_t;
-	')
-
-	corecmd_search_bin($1)
-	can_exec($1, spamc_exec_t)
-')
-
-########################################
-## <summary>
-##	Send kill signals to spamc.
+##	Send kill signal to spamassassin client
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -152,28 +138,28 @@ interface(`spamassassin_kill_client',`
 
 ########################################
 ## <summary>
-##	Execute spamassassin standalone client
-##	in the user spamassassin domain.
+##	Manage spamc home files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_domtrans_local_client',`
+interface(`spamassassin_manage_home_client',`
 	gen_require(`
-		type spamassassin_t, spamassassin_exec_t;
+		type spamc_home_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, spamassassin_exec_t, spamassassin_t)
+	userdom_search_user_home_dirs($1)
+	manage_dirs_pattern($1, spamc_home_t, spamc_home_t)
+	manage_files_pattern($1, spamc_home_t, spamc_home_t)
+	manage_lnk_files_pattern($1, spamc_home_t, spamc_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	spamd home content.
+##	Read spamc home files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -181,20 +167,21 @@ interface(`spamassassin_domtrans_local_c
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_manage_spamd_home_content',`
+interface(`spamassassin_read_home_client',`
 	gen_require(`
-		type spamd_home_t;
+		type spamc_home_t;
 	')
 
 	userdom_search_user_home_dirs($1)
-	allow $1 spamd_home_t:dir manage_dir_perms;
-	allow $1 spamd_home_t:file manage_file_perms;
-	allow $1 spamd_home_t:lnk_file manage_lnk_file_perms;
+	list_dirs_pattern($1, spamc_home_t, spamc_home_t)
+	read_files_pattern($1, spamc_home_t, spamc_home_t)
+	read_lnk_files_pattern($1, spamc_home_t, spamc_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Relabel spamd home content.
+##	Execute the spamassassin client
+##	program in the caller directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -202,49 +189,35 @@ interface(`spamassassin_manage_spamd_hom
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_relabel_spamd_home_content',`
+interface(`spamassassin_exec_client',`
 	gen_require(`
-		type spamd_home_t;
+		type spamc_exec_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 spamd_home_t:dir relabel_dir_perms;
-	allow $1 spamd_home_t:file relabel_file_perms;
-	allow $1 spamd_home_t:lnk_file relabel_lnk_file_perms;
+	can_exec($1, spamc_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in user home
-##	directories with the spamd home type.
+##	Execute spamassassin standalone client in the user spamassassin domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_home_filetrans_spamd_home',`
+interface(`spamassassin_domtrans_local_client',`
 	gen_require(`
-		type spamd_home_t;
+		type spamassassin_t, spamassassin_exec_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, spamd_home_t, $2, $3)
+	domtrans_pattern($1, spamassassin_exec_t, spamassassin_t)
 ')
 
 ########################################
 ## <summary>
-##	Read spamd lib files.
+##	read spamd lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -258,7 +231,9 @@ interface(`spamassassin_read_lib_files',
 	')
 
 	files_search_var_lib($1)
+	list_dirs_pattern($1, spamd_var_lib_t, spamd_var_lib_t)
 	read_files_pattern($1, spamd_var_lib_t, spamd_var_lib_t)
+	read_lnk_files_pattern($1, spamd_var_lib_t, spamd_var_lib_t)
 ')
 
 ########################################
@@ -283,7 +258,7 @@ interface(`spamassassin_manage_lib_files
 
 ########################################
 ## <summary>
-##	Read spamd pid files.
+##	Read temporary spamd file.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -291,56 +266,56 @@ interface(`spamassassin_manage_lib_files
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_read_spamd_pid_files',`
+interface(`spamassassin_read_spamd_tmp_files',`
 	gen_require(`
-		type spamd_var_run_t;
+		type spamd_tmp_t;
 	')
 
-	files_search_pids($1)
-	read_files_pattern($1, spamd_var_run_t, spamd_var_run_t)
+	files_search_tmp($1)
+	allow $1 spamd_tmp_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read temporary spamd files.
+##	Do not audit attempts to get attributes of temporary
+##	spamd sockets/
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_read_spamd_tmp_files',`
+interface(`spamassassin_dontaudit_getattr_spamd_tmp_sockets',`
 	gen_require(`
 		type spamd_tmp_t;
 	')
 
-	allow $1 spamd_tmp_t:file read_file_perms;
+	dontaudit $1 spamd_tmp_t:sock_file getattr_sock_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to get
-##	attributes of temporary spamd sockets.
+##	Connect to run spamd.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain to not audit.
+##	Domain allowed to connect.
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_dontaudit_getattr_spamd_tmp_sockets',`
+interface(`spamd_stream_connect',`
 	gen_require(`
-		type spamd_tmp_t;
+		type spamd_t, spamd_var_run_t;
 	')
 
-	dontaudit $1 spamd_tmp_t:sock_file getattr;
+	files_search_pids($1)
+	stream_connect_pattern($1, spamd_var_run_t, spamd_var_run_t, spamd_t)
 ')
 
 ########################################
 ## <summary>
-##	Connect to spamd with a unix
-##	domain stream socket.
+##	Read spamd pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -348,19 +323,62 @@ interface(`spamassassin_dontaudit_getatt
 ##	</summary>
 ## </param>
 #
-interface(`spamassassin_stream_connect_spamd',`
+interface(`spamassassin_read_pid_files',`
 	gen_require(`
-		type spamd_t, spamd_var_run_t;
+		type spamd_var_run_t;
 	')
 
 	files_search_pids($1)
-	stream_connect_pattern($1, spamd_var_run_t, spamd_var_run_t, spamd_t)
+	read_files_pattern($1, spamd_var_run_t, spamd_var_run_t)
+')
+
+######################################
+## <summary>
+##  Transition to spamassassin named content
+## </summary>
+## <param name="domain">
+##  <summary>
+##      Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`spamassassin_filetrans_home_content',`
+    gen_require(`
+        type spamc_home_t;
+    ')
+
+    userdom_user_home_dir_filetrans($1, spamc_home_t, dir, ".pyzor")
+    userdom_user_home_dir_filetrans($1, spamc_home_t, file, ".spamassassin")
+    userdom_user_home_dir_filetrans($1, spamc_home_t, dir, ".spamd")
+    userdom_user_home_dir_filetrans($1, spamc_home_t, dir, ".razor")
+')
+
+######################################
+## <summary>
+##  Transition to spamassassin named content
+## </summary>
+## <param name="domain">
+##  <summary>
+##      Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`spamassassin_filetrans_admin_home_content',`
+    gen_require(`
+        type spamc_home_t;
+    ')
+
+    userdom_admin_home_dir_filetrans($1, spamc_home_t, dir, ".pyzor")
+    userdom_admin_home_dir_filetrans($1, spamc_home_t, file, ".spamassassin")
+    userdom_admin_home_dir_filetrans($1, spamc_home_t, dir, ".spamd")
+    userdom_admin_home_dir_filetrans($1, spamc_home_t, dir, ".razor")
 ')
 
+
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an spamassassin environment.
+##	All of the rules required to administrate
+##	an spamassassin environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -369,20 +387,22 @@ interface(`spamassassin_stream_connect_s
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the spamassassin domain.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`spamassassin_admin',`
+interface(`spamassassin_spamd_admin',`
 	gen_require(`
 		type spamd_t, spamd_tmp_t, spamd_log_t;
 		type spamd_spool_t, spamd_var_lib_t, spamd_var_run_t;
 		type spamd_initrc_exec_t;
 	')
 
-	allow $1 spamd_t:process { ptrace signal_perms };
+	allow $1 spamd_t:process signal_perms;
 	ps_process_pattern($1, spamd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 spamd_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, spamd_initrc_exec_t)
 	domain_system_change_exemption($1)
@@ -403,6 +423,4 @@ interface(`spamassassin_admin',`
 
 	files_list_pids($1)
 	admin_pattern($1, spamd_var_run_t)
-
-	spamassassin_role($2, $1)
 ')
